const fs = require('fs')
const bodyParser = require('body-parser')
const jsonServer = require('json-server')
const jwt = require('jsonwebtoken')

module.exports = (db, secretKey, port) => {
    const server = jsonServer.create()
    const router = jsonServer.router(db)
    const userdb = JSON.parse(fs.readFileSync(db, 'UTF-8'))

    const PORT = port ? port : "8000";
    const SECRET_KEY = secretKey ? secretKey : "SecretKeyIsSoImportant";

    server.use(bodyParser.urlencoded({extended: true}))
    server.use(bodyParser.json())
    server.use(jsonServer.defaults());

    const expiresIn = '1h'

    server.post('/auth/login', (req, res) => {
      const {email, password} = req.body
      if (userdb.users.findIndex(user => user.email === email && user.password === password) === -1) {
        const status = 401
        const message = 'Incorrect email or password'
        res.status(status).json({status, message})
        return
      }
      const access_token = jwt.sign({email, password}, secretKey, {expiresIn})
      res.status(200).json({access_token})
    })

    server.use(/^(?!\/auth).*$/,  (req, res, next) => {
      if (req.headers.authorization === undefined || req.headers.authorization.split(' ')[0] !== 'Bearer') {
        const status = 401
        const message = 'Error in authorization format'
        res.status(status).json({status, message})
        return
      }
      try {
         jwt.verify(req.headers.authorization.split(' ')[1], secretKey, (err, decode) => decode !== undefined ?  decode : err)
         next()
      } catch (err) {
        const status = 401
        const message = 'Error access_token is revoked'
        res.status(status).json({status, message})
      }
    })

    server.use(router)

    server.listen(PORT, () => {
      console.log(`Server Is Running on http://localhost:${PORT}`)
    })
}
